unit unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CommCtrl, Menus, uOutBar, StdCtrls, ExtCtrls
  {$IFDEF VER120}
  , ImgList
  {$ENDIF}
  ;
Type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    Nouvellepage1: TMenuItem;
    Ajouteritem1: TMenuItem;
    N1: TMenuItem;
    Loadpages1: TMenuItem;
    Savepages1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Clear1: TMenuItem;
    Backgroundcolor1: TMenuItem;
    ColorDialog1: TColorDialog;
    AddnextMenu1: TMenuItem;
    MainMenu1: TMainMenu;
    Files1: TMenuItem;
    Opensomething1: TMenuItem;
    Closesomething1: TMenuItem;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Largeicon1: TMenuItem;
    Smallicon1: TMenuItem;
    N2: TMenuItem;
    Larges: TImageList;
    Smalls: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Nouvellepage1Click(Sender: TObject);
    procedure Ajouteritem1Click(Sender: TObject);
    procedure Loadpages1Click(Sender: TObject);
    procedure Savepages1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Backgroundcolor1Click(Sender: TObject);
    procedure AddnextMenu1Click(Sender: TObject);
    procedure Opensomething1Click(Sender: TObject);
    procedure Closesomething1Click(Sender: TObject);
    procedure Largeicon1Click(Sender: TObject);
    procedure Smallicon1Click(Sender: TObject);
  private
    cusControl : TCustomOutBar;
    procedure loadCusControl;
    procedure setStyle(os:TOutBarStyle);
    procedure cusOnDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure cusOnDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure OnItemClick(Sender: TObject);
    procedure OnItemDblClick(Sender: TObject);
  protected
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$R IMAGES.RES}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Larges.ResourceLoad(rtBitmap,'LARGEIMAGES',clFuchsia);
  Smalls.ResourceLoad(rtBitmap,'SMALLIMAGES',clFuchsia);
  cusControl := TCustomOutBar.Create(self);
  with cusControl do
    begin
      Name   := 'OutBar1';
      Parent := self;
      ALign  := alLeft;
      setStyle(osLargeIcon);
      BackGroundColor  := GetSysColor(COLOR_INACTIVECAPTION);
      Popupmenu := PopupMenu1;
      imgShellFile := 0;
      OnDragOver := cusOnDragOver;
      OnDragDrop := cusOnDragDrop;
      OnClick:= OnItemClick;
      OnDblClick:= OnItemDblClick;
      LargeImages:=Larges;
      SmallImages:=Smalls;

      loadCusControl;
    end;
end;

procedure TForm1.loadCusControl;
var idp,idi:Integer;
begin
  with cusControl do
   begin
     BeginUpdate;

     for idp:=1 to 5 do
       with Pages.Add do
        begin
          Caption := 'Page'+inttostr(idp);
          for idi:=1 to 2+Random(10) do
           begin
             with Add do
               begin
                 Caption := 'A long item caption with many lines '+inttostr(idp)+'-'+inttostr(idi);
                 Imageindex := Random(11);
               end;
           end;
           if Count>2 then Items[2].Enabled := FALSE;
        end;
     PageIndex := 0;
     Pages[2].ReadOnly := TRUE;

     EndUpdate;
   end;
end;

procedure TForm1.OnItemClick(Sender: TObject);
begin
  ShowMessage('Item click : '+cusControl.CurrentItem.Caption);
end;

procedure TForm1.OnItemDblClick(Sender: TObject);
begin
  ShowMessage('Item double click : '+cusControl.CurrentItem.Caption);
end;

procedure TForm1.Nouvellepage1Click(Sender: TObject);
begin
  with cusControl.Pages.Add do
    begin
      Caption := '<New page>';
    end;
end;

procedure TForm1.Ajouteritem1Click(Sender: TObject);
begin
  if Assigned(cusControl.CurrentPage) then
   with cusControl.CurrentPage.Add do
     begin
       Caption    := '<New Item>';
       ImageIndex := Random(11);
       BringToTop;
     end;
end;

procedure TForm1.cusOnDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
end;

procedure TForm1.cusOnDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  //
  Accept := Accept or (Source is TCustomOutBar);
end;

procedure TForm1.Loadpages1Click(Sender: TObject);
begin
  if Not OpenDialog1.execute then Exit;
  with cusControl do
   begin
     Clear;
     Pages.LoadFromFile(Opendialog1.FileName);
   end;
end;

procedure TForm1.Savepages1Click(Sender: TObject);
begin
  if Not SaveDialog1.execute then Exit;
  with cusControl do
   begin
     Pages.SaveToFile(Savedialog1.FileName);
   end;
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  cusControl.Clear;
end;

procedure TForm1.Backgroundcolor1Click(Sender: TObject);
begin
  //
  if Not ColorDialog1.Execute then exit;
  cusControl.BackGroundColor := ColorDialog1.Color;
end;

procedure TForm1.AddnextMenu1Click(Sender: TObject);
begin
  cusControl.HookNextMenuMsg('Shortcut to %s',0);
end;

procedure TForm1.Opensomething1Click(Sender: TObject);
begin
  Showmessage('Open something click');
end;

procedure TForm1.Closesomething1Click(Sender: TObject);
begin
  ShowMessage('Close something click');
end;

procedure TForm1.setStyle(os:TOutBarStyle);
begin
  cusControl.Style := os;
  case os of
   osLargeIcon : begin Largeicon1.Checked := TRUE; Smallicon1.Checked := FALSE; end;
   osSmallIcon : begin Smallicon1.Checked := TRUE; Largeicon1.Checked := FALSE; end;
  end;
end;

procedure TForm1.Largeicon1Click(Sender: TObject);
begin
  if LargeIcon1.Checked
     then setStyle(osSmallIcon)
     else setStyle(osLargeIcon);
end;

procedure TForm1.Smallicon1Click(Sender: TObject);
begin
  if SmallIcon1.Checked
     then setStyle(osLargeIcon)
     else setStyle(osSmallIcon);
end;

end.
